program COURBE3D;   { Courbes parametriques dans l'espace }

Uses Crt, Graph, GRAPH3D;

var  ValDepart, ValFinale : real;
     T, dT                : real;

Function FX (T: real) : real;
begin
   FX := sin(-T)*cos(T)
end;


Function FY (T: real) : real;
begin
   FY := 0.2 * T
end;

Function FZ (T: real) : real;
begin
   FZ := 2 * sin(T)+cos(T)
end;

procedure EntreeDesDonnees;
begin
   ClrScr;
   writeln ('PROJECTION D''UNE COURBE A TROIS DIMENSIONS.');
   writeln ('==========================================');
   gotoXY (1,5);
   writeln ('Intervalle d''tude en radians');
   writeln ('-----------------------------');
   write ('Valeur de dpart    : ');
   readln (ValDepart);
   write ('Valeur finale       : ');
   readln (Valfinale);
   write ('Valeur du pas       : ');
   readln (dT);
   write ('Distance de l''cran : ');
   readln (DE)
end;

procedure Affichage (Titre: string);
begin
   SetTextStyle (SmallFont, HorizDir, 5);
   OutTextXY (250, 335, 'PROJECTION ' + Titre);
end;

procedure FaireProjection (Titre: string);
var X, Y, Z : real;
begin
   EffaceEcran3D;
   Affichage (Titre);
   InitialiseProjection;
   AxesPointilles3D;
   T := ValDepart;
   X := FX(T);
   Y := FY(T);
   Z := FZ(T);
   DeplaceEn3D (X, Y, Z);
   repeat
      T := T + dT;
      X := FX(T);
      Y := FY(T);
      Z := FZ(T);
      TraceVers3D (X, Y, Z)
   until T >= ValFinale;
   Attente3D
end;

BEGIN
   EntreeDesDonnees;
   EcranGraphique3D;
   Cloture3D (0, MaxX, 0, MaxY);
   Projection := Parallele;
   Theta := 0;
   Phi   := 90;
   FaireProjection ('SUR LE PLAN XY');
   Theta := 90;
   Phi   := 0;
   FaireProjection ('SUR LE PLAN XZ');
   Theta := 0;
   Phi   := 0;
   FaireProjection ('SUR LE PLAN YZ');
   Theta := 45;
   Phi   := 35.26439;
   FaireProjection ('ISOMETRIQUE');
   EcranTexte3D

END.
