program FOURIER;          { onde rectangulaire }

uses Crt, Graph, Graph2D;

const Pas = 0.05;

var NbreHarm, Choix : byte;

procedure Menu;
begin
   clrscr;
   writeln ('LES SERIES DE FOURIER');
   writeln ('=====================');
   gotoXY (1,5);
   writeln ('1. On ajoute les harmoniques un  un.');
   writeln ('2. On dessine la rsultante uniquement.');
   writeln;
   write ('N choisi: ');
   readln (Choix);
   gotoXY (1, 10);
   write ('Combien voulez-vous d''harmoniques: ');
   readln (NbreHarm)
end;

procedure TraceSerie;
var Coeff, Signe : integer;
    Harm, N, I   : integer;
    Xi, Yi       : real;
    Y            : table;
begin
   fillchar (Y, sizeof(Y), 0);
   EcranGraphique;
   Fenetre (-0.1, 2*Pi, -1.1, 1.1);
   Cloture (0, MaxX, 0, MaxY);
   Axes;
   Gradue (1,1);
   case Choix of
      1 : begin
             Coeff := -1;
             Signe := 1;
             for Harm := 1 to NbreHarm do
             begin
                Xi := 0;   Yi := 0;   N := 0;
                DeplaceEn (Xi, Yi);
                inc (Coeff, 2);
                while  Xi <= 2.1*Pi do
                begin
                   inc (N);
                   Yi := Y[N] + Signe * sin(Xi * Coeff) / Coeff;
                   TraceVers (Xi, Yi);
                   Y[N] := Yi;
                   Xi := Xi + Pas
                end
             end
          end;
      2 : begin
             Xi := 0;   Yi := 0;
             DeplaceEn (Xi, Yi);
             while  Xi <= 2.1*Pi do
             begin
                Yi := 0;
                Coeff := -1;
                Signe := 1;
                for I := 1 to NbreHarm do
                begin
                   inc (Coeff, 2);
                   Yi := Yi + Signe * sin(Xi * Coeff) / Coeff
                end;
                TraceVers (Xi, Yi);
                Xi := Xi + Pas
             end
          end;
   end
end;

BEGIN
   Menu;
   TraceSerie;
   Attente;
   EcranTexte
END.
