program FractalH;

Uses Crt, Graph, GRAPH2D;

var X1, Y1, X2, Y2, X3, Y3, X4, Y4: array[1..20] of real;
    Ordre : byte;
    A     : real;
    M, N  : integer;

procedure LectureOrdre;
begin
   clrscr;
   write ('Quel est l''ordre > 0 de la fractale : ');
   readln (Ordre)
end;

procedure TraceSegments(S: byte);
var J : integer;
    X, Y, B, C: real;
begin
   for J := S to Ordre do
   begin
      X := X1[J - 1];
      Y := Y1[J - 1];
      B := Puissance (A, J);
      C := A * B * 1.5;
      X1[J] := X + B;      Y1[J] := Y + C;
      X2[J] := X + B;      Y2[J] := Y - C;
      X3[J] := X - B;      Y3[J] := Y + C;
      X4[J] := X - B;      Y4[J] := Y - C;
      DeplaceEn (X - B, Y);           TraceVers (X + B, Y);
      DeplaceEn (X1[J], Y1[J]);       TraceVers (X2[J], Y2[J]);
      DeplaceEn (X3[J], Y3[J]);       TraceVers (X4[J], Y4[J])
   end
end;

procedure DessineFractale;
var S: byte;
begin
   A := 0.5;
   X1[1] := 0;
   Y1[1] := 0;
   S := 1;
   TraceSegments(S);
   for M := 1 to round(Puissance(4, Ordre - 1)) - 1 do
   begin
      N := M;
      S := Ordre;
      while (N mod 4 = 0) do
      begin
         N := N div 4;
         S := S - 1
      end;
      X1[S - 1] := X2[S - 1];      X2[S - 1] := X3[S - 1];
      X3[S - 1] := X4[S - 1];      Y1[S - 1] := Y2[S - 1];
      Y2[S - 1] := Y3[S - 1];      Y3[S - 1] := Y4[S - 1];
      TraceSegments(S)
   end
end;

BEGIN
   LectureOrdre;
   EcranGraphique;
   Fenetre (-1, 1, -1, 1);
   Cloture (140, 580, 15, MaxY);
   DessineFractale;
   Attente;
   EcranTexte
END.

