program  MACCOS;           { Serie de Maclaurin de cosinus }

uses Crt, Graph, Graph2D;

const A   = 0;
      B   = 6.29;
      Pas = 0.1;

var NbreTerme : byte;

procedure EntreeDonnee;
begin
   clrscr;
   writeln ('Representation de COS(X) par la serie de Maclaurin');
   writeln ('==================================================');
   gotoxy(1, 10);
   write ('Entrez le nombre de termes : ');
   readln (NbreTerme)
end;

procedure TraceCosinusoide;
var I : real;
begin
   I := A;
   while I <= B do
   begin
      DeplaceEn (I, cos(I));
      TraceVers (I, cos(I));
      I := I + Pas
   end
end;

procedure TraceCosinusMaclaurin (NbreTerme:byte);
var Terme, Cpt : byte;
    D          : integer;
    X, T       : real;
    Y          : table;
begin
   fillChar (Y, SizeOf(Y), 0);
   D := -2;
   for Terme := 1 to NbreTerme do
   begin
      Cpt := 1;
      D   := D + 2;
      X   := A;
      T   := Puissance(X, D) / Factorielle(D);
      if odd(Terme)
         then  Y[Cpt] := Y[Cpt] + T
         else  Y[Cpt] := Y[Cpt] - T;
      DeplaceEn (X, Y[Cpt]);
      while X <= B do
      begin
         X := X + Pas;
         T := Puissance(X, D) / Factorielle(D);
         Cpt := Cpt + 1;
         if odd(Terme)
            then  Y[Cpt] := Y[Cpt] + T
            else  Y[Cpt] := Y[Cpt] - T;
         TraceVers (X, Y[Cpt])
      end
   end
end;

BEGIN
   EntreeDonnee;
   EcranGraphique;
   Fenetre (-0.1, 6.29,  - 2, 2);
   Cloture (0, MaxX, 0, MaxY);
   Axes;
   Gradue (1, 1);
   Grille (0.5, 0.5);
   TraceCosinusoide;
   TraceCosinusMaclaurin(NbreTerme);
   Attente;
   EcranTexte
END.

