program Mira;

Uses Crt, Graph, Graph2D;

var A, B, X, Y     : real;
    F1, F2, F3, F4 : real;
    NbreIter       : integer;

procedure EntreeDonnees;
begin
   clrscr;
   writeln ('CHAOS ESTHETIQUES DE MIRA');
   writeln ('=========================');
   gotoXY (1, 5);
   write ('Entrez la valeur de A: ');
   readln (A);
   write ('Entrez la valeur de B: ');
   readln (B);
   write ('Entrez la coordonne X,Y de dpart: ');
   readln (X,Y);
   write ('Entrez la fentre: ');
   readln (F1, F2, F3, F4);
   write ('Nombre d''itrations: ');
   readln (NbreIter)
end;

function F (X: real): real;
begin
   F := A *  X + (1 - A) * (2 *sqr(X) / (1 + sqr(X)))
end;

procedure DessineMira (X0, Y0, A, B: real);
var X1, Y1 : real;
    N      : word;
begin
   for N := 0 to NbreIter do
   begin
      DeplaceEn (X0, Y0);
      TraceVers (X0, Y0);
      X1 := B * Y0 + F(X0);
      Y1 := F(X1) - X0;
      X0 := X1;
      Y0 := Y1
   end
end;

procedure Affichage;
var Ch1, Ch2, Ch3, Ch4, Ch5, Ch6, Ch7, Ch8, Ch : string;
begin
   str (A:6:3, Ch1);    str (B:6:3, Ch2);     str (X:6:3, Ch3);
   str (Y:6:3, Ch4);    str (F1:6:3, Ch5);    str (F2:6:3, Ch6);
   str (F3:6:3, Ch7);   str (F4:6:3, Ch8);
   Ch := concat ('A=',Ch1,'  B=',Ch2,'  X0=',Ch3,'  Y0=',Ch4);
   Ch := concat (Ch, '  F1=',Ch5, '  F2=',Ch6, '  F3=',Ch7, '  F4=',Ch8);
   Cloture (0, MaxX, 0, 11);
   OutTextXY (10,0,Ch)
end;

BEGIN
   EntreeDonnees;
   EcranGraphique;
   Fenetre (F1, F2, F3, F4);
   Cloture (140, 580, 15, 345);
   TraceBordure;
   DessineMira (X, Y, A, B);
   Affichage;
   Attente;
   EcranTexte
END.
