program BOLYGONE;

uses Crt, Printer, Plot2D;

var Ordre,Pas   : integer;
    ADeg,ARad   : real;
    F1,F2,F3,F4 : real;
    C1,C2,C3,C4 : real;

procedure EntreeDonnees;
begin
   clrscr;
   write ('Quel est l''Ordre entier du bolygone (0 pour terminer) ');
   readln (Ordre);
   writeln;
   if Ordre <> 0 then
      begin
         write ('Quelle est la valeur en degrs du Pas du trac ');
         readln (Pas);
         F1:=-1.1;f2:=1.1;F3:=-1.1;f4:=1.1;
         writeln;
         write ('Coordonne en CM de la cloture papier:');
         readln (C1, C2, C3, C4)
      end
end;

procedure TraceBolygone (Ordre, Pas: integer);
begin
   ADeg := 0;
   repeat
      ARad := Pi * ADeg / 180;
      DeplaceEn (cos(ARad), sin(ARad));
      TraceVers (cos(Ordre * ARad), sin(Ordre * ARad));
      ADeg := ADeg + Pas
   until ADeg > 360
end;

procedure Affichage;
var S1, S2, Chaine: string;
begin
   writeln (lst,'^IW');     { redfinit WINDOW par dfaut 38cm/27cm }
   str (Ordre:2, S1);
   str (Pas:2, S2);
   Chaine := concat ('ORDRE=',S1,'  PAS=',S2);
   DeplaceEn (XgFen, YhFen);
   writeln (lst,'R',20,',',20);
   writeln (lst,'P', Chaine)
end;

BEGIN
EntreeDonnees;
while Ordre <> 0 do
   begin
      Fenetre (F1, F2, F3, F4);
      Cloture (C1, C2, C3, C4);
      Plume (1);
      TraceBordure;
      TraceBolygone (Ordre,Pas);
      Affichage;
      Plume (0);
      EntreeDonnees
   end
END.
