(* Courbes parametriques dans l'espace - Hlice page 295
   Relire la signification de DE lors d'une projection parallle page 292
   Il n'est pas facile de trouver la bonne valeur de DE, gnralement
   quelques essais seront ncessaires. Pour les essais ne prenez pas des
   valeurs de dpart, d'arrive et de pas trop petites afin d'acclrer
   le trac. D'aprs le rsultat obtenu vous pourrez corriger facilement.
*)

program COURBE3D;

Uses Crt, Printer, Plot3D;

var  ValDepart, ValFinale : real;
     T, dT                : real;
     C1, C2, C3, C4: real;

Function FX (T: real) : real;
begin
   FX := cos(T)
end;

Function FY (T: real) : real;
begin
   FY := sin(T)
end;

Function FZ (T: real) : real;
begin
   FZ := 0.2*T
end;

procedure EntreeDesDonnees;
begin
   ClrScr;
   writeln ('LES 4 VUES EN PROJECTION D''UNE COURBE A TROIS DIMENSIONS.');
   writeln ('========================================================');
   gotoXY (1,5);
   writeln ('Intervalle d''tude en radians');
   writeln ('-----------------------------');
   write ('Valeur de dpart    : ');
   readln (ValDepart);
   write ('Valeur finale       : ');
   readln (Valfinale);
   write ('Valeur du pas       : ');
   readln (dT);
   write ('Distance de l''cran : ');
   readln (DE);
end;

procedure FaireProjection (Titre: string);
var X, Y, Z : real;
begin
   InitialiseProjection;
   Axes;
   T := ValDepart;
   X := FX(T);
   Y := FY(T);
   Z := FZ(T);
   DeplaceEn (X, Y, Z);
   repeat
      T := T + dT;
      X := FX(T);
      Y := FY(T);
      Z := FZ(T);
      TraceVers (X, Y, Z)
   until T >= ValFinale;
end;

BEGIN
   EntreeDesDonnees;
   Plume (1);
   Projection := Parallele;

   Cloture (0,5,5,10);
   Theta := 0;
   Phi   := 90;
   FaireProjection ('SUR LE PLAN XY');

   Cloture (8.5,13.5,5,10);
   Theta := 90;
   Phi   := 0;
   FaireProjection ('SUR LE PLAN XZ');

   Cloture (0,5,0,5);
   Theta := 0;
   Phi   := 0;
   FaireProjection ('SUR LE PLAN YZ');

   Cloture (8.5,13.5,0,5);
   Theta := 45;
   Phi   := 35.26439;
   FaireProjection ('ISOMETRIQUE');

   Plume (0)
END.
