program DRAGON1;

Uses Crt, Graph, Plot2D;

var Ordre : byte;
    C1, C2, C3, C4: real;

procedure LireDonnees;
begin
   clrscr;
   writeln ('LA COURBE DU DRAGON');
   writeln ('===================');
   gotoXY (1,10);
   write ('Quel est l''ordre de la courbe: ');
   readln (Ordre);
   write ('Cloture: ');
   readln (C1, C2, C3, C4)
end;

procedure DessineDragon;
var Puis, X1, Y1, XA, YA, XB, YB, X2, Y2,Angle : real;
    Dir, Som, Aux, N  : integer;
begin
   Puis := Puissance (2, -Ordre/2);
   Som := 0;
   X1 := Puis * cos(Ordre * Pi / 4);
   Y1 := -Puis * sin(Ordre * Pi / 4);
   DeplaceEn (0, 0);
   TraceVers (0.75 * X1, 0.75 * Y1);
   for N := 1 to round(Puissance (2, Ordre)) - 1 do
   begin
      Aux := N;
      while (Aux mod 2 = 0) do Aux := Aux div 2;
      if (Aux mod 4 = 1) then Dir := 1 else Dir := -1;
      Som := (Som + Dir) mod 4;
      Angle := (Som - Ordre / 2) * Pi / 2;
      X2 := X1 + Puis * cos(Angle);
      Y2 := Y1 + Puis * sin(Angle);
      XA := (3 * X1 + X2) / 4;
      YA := (3 * Y1 + Y2) / 4;
      TraceVers (XA, YA);
      XB := (X1 + 3 * X2) / 4;
      YB := (Y1 + 3 * Y2) / 4;
      TraceVers (XB, YB);
      X1 := X2;
      Y1 := Y2
   end;
   TraceVers (1, 0)
end;

BEGIN
   LireDonnees;
   Plume (1);
   Fenetre (-0.4, 1.2, -0.9, 0.7);
   Cloture (C1, C2, C3, C4);
   DessineDragon;
   Plume (0)
END.


