(* Le fameux problme des reines sur l'chiquier *)

program Reines;

Uses crt;

var R      : array [1..8] of byte;
    I, J   : byte;
    TestOK : boolean;
    Fin    : boolean;
    Ordre  : byte;

procedure TestReinesPrecedentes;
begin
   TestOK := true;
   J      := 1;
   while (J <= I - 1) and (TestOK = true) do
   begin
      if (R[I]=R[J]) or (abs(R[I]-R[J])=I-J) then TestOK:=false;
      J := J + 1
   end
end;

procedure DescenteColonne;
begin
   R[I] := 0;
   I    := I - 1;
   if I = 0 then Fin := true
            else I := I - 1
end;

procedure AffichageSolution;
var Ch, Chaine : string;
    Long       : byte;
begin
   Chaine := '';
   for J := 1 to Ordre do
   begin
      str(R[J], Ch);
      Chaine := concat(Chaine, Ch)
   end;
   Long := length (Chaine);
   write (Chaine,' ':10 - Long)
end;

BEGIN
   clrscr;
   repeat
      write ('Quel est l''ordre de l''chiquier (de 4  8) : ');
      readln (Ordre)
   until (Ordre > 3) and (Ordre < 9);
   writeln;
   fillchar (R, sizeof(R), 0);
   Fin  := false;
   I    := 0;
   while not (Fin) do
   begin
      I := I + 1;
      while (I <= Ordre) and not (Fin) do
      begin
         TestOK := false;
         while (R[I] < Ordre) and not(TestOK) do
         begin
            R[I] := R[I] + 1;
            TestReinesPrecedentes
         end;
         if not (TestOK) then DescenteColonne;
         I := I + 1
      end;
      if not (Fin) then begin
                           AffichageSolution;
                           R[Ordre] := 0;
                           I := Ordre - 2
                        end
   end
END.

