program  COMPVIBR;

uses Crt, Graph, Graph2D;

const Pas = 0.02;

var  F1, F2, A1, A2, D, B, P, X : real;

procedure EntreeDesDonnees;
begin
   clrscr;
   writeln ('COMPOSITION DE DEUX VIBRATIONS');
   writeln ('==============================');
   gotoXY(1,10);write ('VIBRATION 1:frequence,amplitude :');
   readln (F1, A1);
   gotoXY(1,14);write ('VIBRATION 2:frequence,amplitude,dephasage :');
   readln (F2, A2, D)
end;

function Fonction1 (X: real) : real;
begin
   Fonction1 := A1 * sin (F1 * X)
end;

function Fonction2 (X: real) : real;
begin
   Fonction2 := A2 * sin (F2 * X + D)
end;

function FonctionSomme (X: real) : real;
begin
   FonctionSomme := Fonction1 (X) + Fonction2 (X)
end;

procedure TraceFonction1;
begin
   Fenetre (0, 2 * Pi, -A1, A1);
   Cloture (5, 710, 260, 340);
   Axes;
   Gradue (1, 0);
   X := 0;
   DeplaceEn (X, Fonction1 (X));
   Repeat
      X := X + Pas;
      TraceVers (X, Fonction1 (X))
   Until X >= 2 * Pi
end;

procedure TraceFonction2;
begin
   Fenetre (0, 2 * Pi, -A2, A2);
   Cloture (5, 710, 170, 250);
   Axes;
   Gradue (1, 0);
   X := 0;
   DeplaceEn (X, Fonction2 (X));
   Repeat
      X := X + Pas;
      TraceVers (X, Fonction2 (X))
   Until X >= 2 * Pi
end;

procedure TraceFonctionSomme;
begin
   Fenetre (0, 2 * Pi, -A1-A2, A1+A2);
   Cloture (5, 710, 0, 160);
   Axes;
   Gradue (1, 0);
   X := 0;
   DeplaceEn (X, FonctionSomme (X));
   Repeat
      X := X + Pas;
      TraceVers (X, FonctionSomme (X))
   Until X >= 2 * Pi
end;

BEGIN
   EntreeDesDonnees;
   EcranGraphique;
   TraceFonction1;
   TraceFonction2;
   TraceFonctionSomme;
   Attente;
   EcranTexte
END.

