program DEFORM1;       { Deformation de figures sans trous }

{$M$8000,$0,$A0000}

uses Crt, Graph, Graph2D;

const NbreDefor = 50;
      Lim       = 6;

var  XA, YA, XD, YD : Table;

procedure EntreeFigureDepart;
begin
   XD[1] := 70;   YD[1] := 10;
   XD[2] := 70;   YD[2] := 90;
   XD[3] := 50;   YD[3] := 90;
   XD[4] := 20;   YD[4] := 40;
   XD[5] := 70;   YD[5] := 40;
   XD[6] := 80;   YD[6] := 40;
   DessinePolygone(XD, YD, LIM, 'Ouvert');
   Cloture (140, 500, 0, 15);
   outtextXY (150, 1, 'FIGURE DE DEPART');
   Cloture (140, 500, 15, 345);
   Attente;
   ClearDevice
end;

procedure EntreeFigureArrivee;
begin
   XA[1] := 80;  YA[1] := 90;
   XA[2] := 30;  YA[2] := 90;
   XA[3] := 30;  YA[3] := 50;
   XA[4] := 80;  YA[4] := 50;
   XA[5] := 80;  YA[5] := 10;
   XA[6] := 30;  YA[6] := 10;
   DessinePolygone(XA, YA, LIM, 'Ouvert');
   Cloture (140, 500, 0, 15);
   outtextXY (150, 1, 'FIGURE D''ARRIVEE');
   Cloture (140, 500, 15, 345);
   Attente;
   ClearDevice
end;

procedure Deformation(var XD, YD, XA, YA: table);
var I, J   : integer;
    XR, YR : table;
begin
   for i := 1 to NbreDefor + 1 do
   begin
      for J := 1 to LIM do
      begin
         XR[J] := XD[J] + I * (XA[J]-XD[J]) / (NbreDefor+1);
         YR[J] := YD[J] + I * (YA[J]-YD[J]) / (NbreDefor+1)
      end;
      DessinePolygone(XR, YR, LIM, 'Ouvert');
      EffacePolygone(XR, YR, LIM, 'Ouvert')
   end;
   DessinePolygone(XR, YR, LIM, 'Ouvert')
end;

BEGIN
   EcranGraphique;
   Fenetre (0, 100, 0, 100);
   Cloture (140, 580, 15, 345);
   EntreeFigureDepart;
   EntreeFigureArrivee;
   Deformation(XD, YD, XA, YA);
   Attente;
   EcranTexte
END.
