program Deform2;     {Deformation de figures avec trous }

{$M$8000,$0,$A0000}

uses Crt, Graph, Graph2D;

const NbDefor = 50;
      Lim     = 7;

var  XA, YA, XD, YD, Code : Table;

procedure TracePolygone(XR, YR: Table);
var I : integer;
begin
   For I := 1 to Lim do if Code[I] = 0
                           then DeplaceEn (XR[i], YR[i])
                           else TraceVers (XR[i], YR[i])
end;

procedure EntreeFigureDepart;
begin
   XD[1] := 90;    YD[1] := 80;    Code[1] := 0;
   XD[2] := 10;    YD[2] := 80;    Code[2] := 1;
   XD[3] := 30;    YD[3] := 80;    Code[3] := 1;
   XD[4] := 30;    YD[4] := 10;    Code[4] := 1;
   XD[5] := 30;    YD[5] := 80;    Code[5] := 1;
   XD[6] := 70;    YD[6] := 80;    Code[6] := 0;
   XD[7] := 70;    YD[7] := 10;    Code[7] := 1;
   TracePolygone(XD, YD);
   Cloture (140, 500, 0, 15);
   outtextXY (150, 1, 'FIGURE DE DEPART');
   Cloture (140, 500, 15, 345);
   Attente;
   ClearDevice
end;

procedure EntreeFigureArrivee;
begin
   XA[1] := 20;    YA[1] := 10;
   XA[2] := 20;    YA[2] := 80;
   XA[3] := 60;    YA[3] := 80;
   XA[4] := 60;    YA[4] := 50;
   XA[5] := 20;    YA[5] := 50;
   XA[6] := 80;    YA[6] := 80;
   XA[7] := 80;    YA[7] := 10;
   TracePolygone(XA, YA);
   Cloture (140, 500, 0, 15);
   outtextXY (150, 1, 'FIGURE D''ARRIVEE');
   Cloture (140, 500, 15, 345);
   Attente;
   ClearDevice
end;

procedure Deformation(XD, YD, XA, YA: table);
var I, J   : integer;
    XR, YR : table;
begin
   for I := 1 to NbDefor + 1 do
   begin
      for J := 1 to LIM do
      begin
         XR[J] := XD[J] + I * (XA[J] - XD[J]) / (NbDefor + 1);
         YR[J] := YD[J] + I * (YA[J] - YD[J]) / (NbDefor + 1)
      end;
      Couleur (Blanc);
      TracePolygone(XR, YR);
      Couleur (Noir);
      TracePolygone(XR, YR)
   end;
   Couleur (Blanc);
   TracePolygone(XR, YR)
end;

BEGIN
   EcranGraphique;
   Fenetre (0, 100, 0, 100);
   Cloture (140, 580, 15, 345);
   EntreeFigureDepart;
   EntreeFigureArrivee;
   Deformation(XD, YD, XA, YA);
   Attente;
   EcranTexte
END.
