program FRACFILE;     { programme qui enregistre/corrige un fichier fractal }

uses crt;

var XBase, YBase   : array [0..10] of real;
    XGen, YGen     : array [0..20] of real;
    Fichier        : text;
    NomCourbe      : string [30];
    NomFic         : string [12];
    PointsBase     : byte;
    PointsGen      : byte;
    F1, F2, F3, F4 : real;
    Num            : char;

procedure EntreeDesDonnees;
var N, Ligne: byte;
begin
   clrscr;
   writeln ('Cration d''un fichier FRACTAL');
   writeln ('=============================');
   writeln;
   write ('Nom de la courbe (30 car. max): ');
   readln (NomCourbe);
   write ('Nom du fichier ( 8 car. max)  : ');
   readln (NomFic);
   NomFic := concat (NOMFIC,'.TXT');
   write ('Nombre de points sur la BASE  : ');
   readln (PointsBase);
   writeln;
   Ligne := 8;
   for N := 1 to PointsBase do
   begin
      write ('Point ', N:2, '    X = ');
      readln (XBase[N-1]);
      GotoXY (40, Ligne);
      write ('Y = ');
      readln (YBase[N-1]);
      Ligne := Ligne + 1
   end;
   XBase[PointsBase] := XBase[0];
   YBase[PointsBase] := YBase[0];
   writeln;
   write ('Nombre de points sur la GENERATRICE : ');
   readln (PointsGen);
   writeln;
   Ligne := Ligne + 3;
   for N := 1 to PointsGen do
   begin
      write ('Point ', N:2, '    X = ');
      readln (XGen[N-1]);
      GotoXY (40, Ligne);
      write ('Y = ');
      readln (YGen[N-1]);
      Ligne := Ligne + 1
   end;
   writeln;
   write ('Entrez la fentre de vision : ');
   readln (F1, F2, F3, F4)
end;

procedure Enregistrement;
var N: byte;
begin
   assign (Fichier, NomFic);
   rewrite (Fichier);
   writeln (Fichier, NomCourbe);
   writeln (Fichier, NomFic);
   writeln (Fichier, PointsBase);
   for N := 0 to PointsBase do
   begin
      writeln (Fichier, XBase[N]);
      writeln (Fichier, YBase[N])
   end;
   writeln (Fichier, PointsGen);
   for N := 0 to PointsGen - 1 do
   begin
      writeln (Fichier, XGen[N]);
      writeln (Fichier, YGen[N])
   end;
   writeln (Fichier, F1);
   writeln (Fichier, F2);
   writeln (Fichier, F3);
   writeln (Fichier, F4);
   close (Fichier)
end;

procedure Creation;
begin
   EntreeDesDonnees;
   Enregistrement
end;

procedure LectureFichier;
var N: byte;
begin
   clrscr;
   writeln (' ':20,'CORRECTION D''UN FICHIER FRACTAL');
   writeln (' ':20,'===============================');
   gotoXY (20,6);
   clrscr;
   write ('Nom du fichier  lire: ');
   readln (Nomfic);
   Nomfic := concat (Nomfic, '.TXT');
   assign (Fichier, NomFic);
   reset (Fichier);
   readln (Fichier, NomCourbe);
   readln (Fichier, NomFic);
   readln (Fichier, PointsBase);
   for N := 0 to PointsBase do
   begin
      readln (Fichier, XBase [N]);
      readln (Fichier, YBase [N])
   end;
   readln (Fichier, PointsGen);
   for N := 0 to PointsGen - 1 do
   begin
      readln (Fichier, XGen [N]);
      readln (Fichier, YGen [N])
   end;
   readln (Fichier, F1);
   readln (Fichier, F2);
   readln (Fichier, F3);
   readln (Fichier, F4);
   close (Fichier)
end;

procedure Corrige;
var I    : byte;
    X, Y : real;
    Ch   : string;
    Code : integer;
begin
   clrscr;
   write (NomCourbe,'   ? ');
   readln (Ch);
   if Ch <>'' then NomCourbe := Ch;
   write (NomFic,'   ?');
   readln (Ch);
   if Ch <> '' then NomFic := Ch;
   writeln;
   writeln ('PointsBase=',PointsBase);
   for I:= 0 to PointsBase -1 do
   begin
      write ('X=',XBase[I]:10:6,'   ? ');
      readln (ch); if ch<>'' then val (ch, XBase[I],Code);
      write ('Y=',YBase[I]:10:6,'   ? ');
      readln (ch); if ch<>'' then val (ch, YBase[I],Code)
   end;
   XBase[PointsBase] := XBase[0];
   YBase[PointsBase] := YBase[0];
   writeln;
   writeln ('PointsGen=',PointsGen);
   for I:= 0 to PointsGen-1 do
   begin
      write ('X=',XGen[I]:10:6,'   ? ');
      readln (ch); if ch<>'' then val (ch, XGen[I],Code);
      write ('Y=',YGen[I]:10:6,'   ? ');
      readln (ch); if ch<>'' then val (ch, YGen[I],Code);
   end;
   writeln;
   write ('F1=',F1,'   ? ');
   readln (ch); if ch<>'' then val (ch, F1,Code);
   write ('F2=',F2,'   ? ');
   readln (ch); if ch<>'' then val (ch, F2,Code);
   write ('F3=',F3,'   ? ');
   readln (ch); if ch<>'' then val (ch, F3,Code);
   write ('F4=',F4,'   ? ');
   readln (ch); if ch<>'' then val (ch, F4,Code)
end;

procedure Correction;
begin
   LectureFichier;
   Corrige;
   Enregistrement
end;

BEGIN
   while true do
   begin
   clrscr;
   writeln ('FICHIER FRACTAL');
   writeln ('===============');
   writeln;
   writeln ('1. Cration    -    2. Correction    -    3. Quitter');
   writeln;
   write ('Numro choisi: ');
   readln (Num);
   case Num of
     '1': Creation;
     '2': Correction;
     '3': exit;
     else writeln (#7)
   end
   end
END.
