(* Pour imprimer les DATA des fichiers .TXT pour le programme PEINTRE
   Si le fichier de sortie est CON on imprime sur l'cran
   Si le fichier de sortie est PRN on imprime sur l'imprimante
   Si le fichier de sortie est un Nom de fichier on sauve le fichier lu
      sur le disque sous cet autre nom.
*)

program IMPDATA;       { Imprimer les DATA des fichiers .TXT }

Uses Crt, Printer;

var NbreSt, NbreFc       : integer;
    NomFic, Sortie       : string;
    FicSortie, FicEntree : text;
    Imprimante           : boolean;

procedure OuvertureFichierDonnees;
var IOCode: integer;
    Ch    : char;
begin
   {$I-}
   repeat
      ClrScr;
      write ('Nom du fichier DATA  lire: ');
      readln (NomFic);
      NomFic := concat(NomFic, '.TXT');
      assign (FicEntree, NomFic);
      reset (FicEntree);
      IOCode := IOResult;
      if IOCode <> 0
      then begin
              GotoXY(10,10);
              writeln ('Le fichier ',NomFic,' n''existe pas ....');
              repeat until KeyPressed;
              Ch := ReadKey
           end
   until IOCode = 0;
   {$I+}
   write ('Nom du fichier de sortie <Nom/Con/Prn>:');
   readln (Sortie);
   assign (FicSortie, Sortie);
   rewrite (FicSortie)
end;

procedure LectureSommetsEtFaces;
var X, Y, Z         : real;
    I, J, NS, St, K : integer;
    Ch              : string;
begin
   writeln (FicSortie,'FICHIER ', NomFic);
   writeln(FicSortie);
   readln (FicEntree, NbreSt);
   writeln (FicSortie,'NBRE DE SOMMETS:', NbreSt:4);
   writeln (FicSortie,'---------------');
   for I := 1 to NbreSt do
   begin
      str(I:2, Ch);
      readln (FicEntree, X,Y,Z);
      writeln (FicSortie, Ch:3,') ',X:8:3, Y:8:3, Z:8:3);
   end;
   writeln(FicSortie);
   writeln (FicSortie,'LES FACES');
   writeln (FicSortie,'---------');
   readln (FicEntree, NS);
   K :=1;  str(K:3,Ch);
   write (FicSortie, Ch, ') ',NS:5);
   while NS <> 0 do
   begin
      for J:= 1 to NS do begin
                            readln (FicEntree, St);
                            write (FicSortie, St:5)
                         end;
      writeln(FicSortie);
      K := K + 1;   str(K:3, Ch);
      readln (FicEntree, NS);
      write (FicSortie, Ch, ') ',NS:5);
   end;
   writeln(FicSortie);
   close (FicSortie);
   close (FicEntree)
end;

BEGIN
   OuvertureFichierDonnees;
   LectureSommetsEtFaces;
END.

