program  MACEXP;           { Serie de Maclaurin de y = exp(x) }

uses Crt, Graph, Graph2D;

const A   = -8;
      B   = 5;
      Pas = 0.2;

var NbreTerme : byte;

procedure EntreeDonnee;
begin
   clrscr;
   writeln ('Representation de EXP(X) par la serie de Maclaurin');
   writeln ('==================================================');
   gotoxy(1, 10);
   write ('Entrez le nombre de termes : ');
   readln (NbreTerme)
end;

procedure TraceExponentielle;
var I : real;
begin
   I := A;
   While I <= B do
   begin
      DeplaceEn (I, exp(I));
      TraceVers (I, exp(I));
      I := I + Pas
   end
end;

procedure TraceExponentielleMaclaurin (NbreTerme: byte);
var Terme, Cpt : byte;
    D          : integer;
    X, T       : real;
    Y          : table;
begin
   FillChar (Y, SizeOf(Y), 0);
   D := -1;
   for Terme := 1 to NbreTerme do
   begin
      Cpt := 1;
      D   := D + 1;
      X   := A;
      T   := Puissance(X, D) / Factorielle(D);
      Y[Cpt] := Y[Cpt] + T;
      DeplaceEn (X, Y[Cpt]);
      while X <= B do
      begin
         X := X + Pas;
         T := Puissance(X, D) / Factorielle(D);
         Cpt := Cpt + 1;
         Y[Cpt] := Y[Cpt] + T;
         TraceVers (X, Y[Cpt])
      end
   end
end;

BEGIN
   EntreeDonnee;
   EcranGraphique;
   Fenetre (-8, 5, -3, 7);
   Cloture (0, 719, 0, 347);
   Axes;
   Gradue (1, 1);
   Grille (1, 1);
   TraceExponentielle;
   TraceExponentielleMaclaurin(NbreTerme);
   Attente;
   EcranTexte
END.
