program Moindre2;       (* Droite des moindres carrs *)

uses Crt, Graph, Graph2D;

var X, Y: Table;
    N : integer;
    F1, F2, F3, F4: real;
    A, B: real;

procedure LectureDonnees;
var Xi, Yi: real;
begin
   clrscr;
   N := 0;
   write ('Coordonne du point',N+1:3,' <0, 0> pour terminer : ');
   readln (Xi, Yi);
   while (Xi <> 0) and (Yi <> 0) do
   begin
      Inc (N);
      X [N] := Xi;
      Y [N] := Yi;
      write ('Coordonne du point',N+1:3,' <0, 0> pour terminer : ');
      readln (Xi, Yi)
   end
end;

procedure Calculs;
var SX, SY, SXY, SX2: real;
    Xi, Yi, D: real;
    I: integer;
begin
   SX := 0;  SY := 0;  SXY := 0;  SX2 := 0;
   F1 := 1E20;  F2 := -1E20;  F3 := 1E20;   F4 := - 1E20;
   for I := 1 to N do
   begin
      Xi := X [I];   Yi := Y [I];
      SX := SX + Xi;
      SY := SY + Yi;
      SXY := SXY + Xi * Yi;
      SX2 := SX2 + sqr(Xi);
      if Xi < F1 then F1 := Xi;
      if Xi > F2 then F2 := Xi;
      if Yi < F3 then F3 := Yi;
      if Yi > F4 then F4 := Yi
   end;
   D := N * SX2 - SX * SX;
   A := (N * SXY - SX * SY) / D;
   B := (SY * SX2 - SX * SXY) / D;
   F2 := F2 + 0.1 * (F2 - F1);
   F4 := F4 + 0.1 * (F4 - F3);
   if F1 > 0 then F1 := 0;
   if F3 > 0 then F3 := 0
end;

procedure TraceCroix (X, Y: real);
begin
   DeplaceEn (X, Y);
   MoveRel (-5,0);      LineRel (10,0);
   MoveRel (-5, -5);    LineRel (0, 10)
end;

procedure TraceDroite;
var Xi, Yi: real;
    I: integer;
begin
   EcranGraphique;
   Fenetre (F1, F2, F3, F4);
   Cloture (0, MaxX, 15, MaxY);
   Axes;
   Gradue (1, 1);
   for I := 1 to N do
   begin
      Xi := X[I];   Yi := Y[I];
      TraceCroix (Xi, Yi)
   end;
   DeplaceEn (F1, A * F1 + B);
   TraceVers (F2, A * F2 + B)
end;

procedure AfficheResultat;
var S, Ch: string;
begin
   Str (A:10:6, S);
   Ch := concat ('Y = ', S, ' X ');
   if B > 0 then Ch := concat (Ch, ' + ');
   Str (B:10:6, S);
   Ch := concat (Ch, S);
   OutTextXY (100, 0, Ch)
end;

BEGIN
   LectureDonnees;
   Calculs;
   TraceDroite;
   AfficheResultat;
   Attente;
   EcranTexte
END.

