program OPART;

uses Crt, Graph, Graph2D;

const Lim = 3;
var NbreTri, DivCote, Repet : byte;
    X, Y                    : table;

  procedure EntreeDesDonnees;
  begin
     clrscr;
     writeln ('DESSIN OP''ART');
     writeln ('=============');
     gotoXY (1,10);Write ('Nombre de triangles          : ');
     Readln (NbreTri);
     gotoXY (1,12);Write ('Que vaut le diviseur du ct : ');
     Readln (DivCote);
     gotoXY (1,14);Write ('Nombre de repetitions        : ');
     Readln (Repet)
  end;

procedure Dessine(NbreTri, DCot, Rep : byte);
Var  Angle, Coef  : real;
     NumTri, I, J : byte;
begin
   Coef := 2 * Pi / NbreTri;
   for NumTri := 1 to NbreTri do
      begin
         X[1]  := 0;
         Y[1]  := 0;
         Angle := (NumTri - 1) * Coef;
         X[2]  := cos(Angle);
         Y[2]  := sin(Angle);
         Angle := NumTri * Coef;
         X[3]  := cos(Angle);
         Y[3]  := sin(Angle);
         X[4]  := 0;
         Y[4]  := 0;
         for I := 1 to Rep do
         begin
            DessinePolygone (X, Y, Lim, Ferme);
            if Odd(NumTri)
              then        (* Cas des triangles de numero impair *)
                 begin
                    for J := Lim + 1 downto 2 do
                      begin
                         X[J] := X[J] + (X[J - 1] - X[J]) / DCot;
                         Y[J] := Y[J] + (Y[J - 1] - Y[J]) / DCot
                      end;
                      X[1] := X[Lim + 1];
                      Y[1] := Y[Lim + 1]
                 end
              else       (* Cas des triangles de numero pair *)
                begin
                   for J := 1 to Lim do
                     begin
                        X[J] := X[J] + (X[J + 1] - X[J]) / DCot;
                        Y[J] := Y[J] + (Y[J + 1] - Y[J]) / DCot
                     end;
                     X[Lim + 1] := X[1];
                     Y[Lim + 1] := Y[1]
                end
         end
      end
end;

BEGIN
   EntreeDesDonnees;
   EcranGraphique;
   Fenetre (-1, 1, -1, 1);
   Cloture (140, 580, 15, 345);
   Dessine(NbreTri, DivCote, Repet);
   Attente;
   EcranTexte
END.
