program PolyTour;

uses Crt, Graph, Graph2D;

var OrdrePoly, DivCote, NbrePoly, I : byte;
    X, Y                            : table;

  procedure EntreeDesDonnees;
  begin
     clrscr;
     writeln ('Les polygones qui tournent');
     writeln ('==========================');
     gotoxy (1, 10);
     write ('Quel est l''ordre du polygone?  ');
     readln (OrdrePoly);
     gotoxy (1, 12);
     write ('Que vaut le diviseur du ct? ');
     readln (DivCote);
     gotoxy (1, 14);
     write ('Combien faut-il de polygones? ');
     readln (NbrePoly)
  end;

  procedure RemplirTableCoord;
  var  Angle, Pas : real;
       I          : byte;
  begin
     Angle := 0;
     Pas   := 2 * Pi / OrdrePoly;
     for I := 1 to OrdrePoly do
         begin
            X[I]  := cos(Angle);
            Y[I]  := sin(Angle);
            Angle := Angle + Pas
         end;
         I := I + 1;
         X[I] := X[1];
         Y[I] := Y[1]
  end;

  procedure CalculePolygoneSuivant;
  var  I : byte;
  begin
     for I := 1 to OrdrePoly do
     begin
        X[I] := X[I] + (X[I + 1] - X[I]) / DivCote;
        Y[I] := Y[I] + (Y[I + 1] - Y[I]) / DivCote
     end;
     I := I + 1;
     X[I] := X[1];
     Y[I] := Y[1]
  end;

BEGIN
   EntreeDesDonnees;
   EcranGraphique;
   Fenetre (-1, 1, -1, 1);
   Cloture (140, 580, 15, 345);
   RemplirTableCoord;
   for I := 1 to NbrePoly do
   begin
      DessinePolygone (X, Y, OrdrePoly, Ferme);
      CalculePolygoneSuivant
   end;
   Attente;
   EcranTexte
END.
